<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve 1 question of binary tree</p>
		<button onclick="largest_diffrence()">Largest Diffrence</button>
		<p id="demo"></p>

		<script>
			function largest_diffrence() {
			
				// Node class
				class Node {
					constructor(data)
					{
						this.data = data;
						this.left = null;
						this.right = null;
					}
				}
				
				// Binary Search tree class
				class Tree {
					constructor() {
					// root of a binary seach tree
					this.root = null;
				}
				
                // returns root of the tree
			    getRootNode() {
				    return this.root;
			    }
			
            }


            // Returns maximum value in a given Binary Tree 
            function findMax(root) { 
                // Base case 
                if (root == null) 
                    return -1000000; 
            
                var res = root.data; 
                var lres = findMax(root.left); 
                var rres = findMax(root.right); 
                if (lres > res) 
                    res = lres; 
                if (rres > res) 
                    res = rres; 
                return res; 
            }

            // Returns minimum value in a given Binary Tree 
            function findMin(root) 
            { 
                // Base case 
                if (root == null) 
                    return 1000000; 
            
                var res = root.data; 
                var lres = findMin(root.left); 
                var rres = findMin(root.right); 
                if (lres < res) 
                    res = lres; 
                if (rres < res) 
                    res = rres; 
                return res; 
            }

            //function for getting maximum difference in tree
            function maxDiffrence(root) {
                var leftDiffrence = root.data - findMin(root);
                var rightDiffrence = root.data - findMax(root);
                return leftDiffrence>rightDiffrence ? leftDiffrence : rightDiffrence;
            }

            //get max diffrence for each node
            function maxDiff(root) {
                if(root !== null) {
					maxDiff(root.left);
					maxArray.push(maxDiffrence(root));
					maxDiff(root.right);
				}   
            }
            // create an object for the Tree
            var tree = new Tree();
            tree.root = new Node(4);
            tree.root.left = new Node(2);
            tree.root.right = new Node(5);
            tree.root.left.left = new Node(1);
            tree.root.left.right = new Node(3)
            tree.root.right.left = new Node(-33);
            tree.root.right.right = new Node(50);            
            var maxArray = [];
            var rootNode = tree.getRootNode();
            maxDiff(rootNode);
            console.log(Math.max(...maxArray));
        }
		</script>

	</body>
</html>